//
//  AliMNSSubscription.h
//  AlibabaCloudMNSiOS
//
//  Created by David Chen on 28/03/2017.
//  Copyright © 2017 AliCloud. All rights reserved.
//
#import <Foundation/Foundation.h>

typedef enum
{
    ALIMNS_TOPIC_BACKOFF_RETRY,
    ALIMNS_TOPIC_EXPONENTIAL_DECAY_RETRY
} NotifyStrategy;

typedef enum
{
    ALIMNS_TOPIC_XML,
    ALIMNS_TOPIC_JSON,
    ALIMNS_TOPIC_SIMPLIFIED
}NotifyContentFormat;

@interface AliMNSSubscription : NSObject
@property NSString* topicOwner;
@property NSString* topicName;
@property NSString* subscriptionName;
@property NSString* endpoint;
@property NSString* filterTag;
@property NotifyStrategy notifyStrategy;
@property NotifyContentFormat notifyContentFormat;
@property NSInteger createTime;
@property NSInteger lastModifyTime;
@property NSString* subscriptionUrl;
@property NSString* subscriber;

-(id) initWithTopicName:(NSString*) pTopicName
   withSubscriptionName:(NSString*) pSubscriptionName;
@end
